/////////////////////////////////////////////////////////////////////////////////////////////////////////

ENTITY* target_crumb;
ENTITY* healer_entity;

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function health_indicator();

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function crumb_init()
{
	set (my, INVISIBLE); // no need to see the breadcrumbs
	my.z += 10; // experimental value, keeps npc's feet on the floor
	set (my, PASSABLE); // player's movement code should ignore passable entities
	my.emask |= ENABLE_SCAN; // the crumb is sensitive to c_scan instructions
}

function breadcrumbs_startup()
{
	VECTOR player_pos1[3];
	VECTOR player_pos2[3];
	var step = 1;
	// make sure that player's action includes a "player = my;" line of code
	while (!player) {wait (1);} 
	while (1)
	{
		if (step == 0)
		{
			step = 1;
			vec_set(player_pos1.x, player.x); // store the initial player position
		}
		vec_set(player_pos2.x, player.x); // store the initial player position
		if (vec_dist (player_pos2.x, player_pos1.x) > 50) // create a breadcrumb every 50 quants
		{
			// allow player_pos1 to be set to a new value (approximately equal with the last player_pos2 value)
			step = 0; 
			ent_create("crumb.mdl", player.x, crumb_init);
		}
		wait (1);
	}
}

function damage_healer()
{
	if (you.skill30 != 1) {return;} // didn't collide with an enemy projectile (a donut)? Then nothing should happen
	my.health -= 10;
}

action healer() // this character follows the player using the breadcrumbs
{
	healer_entity = my;
	ent_create ("health.pcx", nullvector, health_indicator);
	VECTOR temp[3];
	// remove the comment bellow if you want to allow the player to pass through the npc character on a narrow hallway, etc
	//	set (my, PASSABLE);
	my.health = 100;
	my.emask = ENABLE_IMPACT | ENABLE_ENTITY;
	my.event = damage_healer;
	while (!player) {wait (1);}
	while (vec_dist (player.x, my.x) < 300) // wait until the player starts to move
	{
		my.skill22 += 4 * time_step; // 4 gives the "stand" animation speed
		ent_animate(my, "idle", my.skill22, ANM_CYCLE);
		wait (1);
	}
	while (my.health > 0)
	{
		if (player.health <= 0) {break;} // the healer dies if player's health goes below zero
		// don't do anything if it's not needed and the player is very close
		while (vec_dist (player.x, my.x) < 200)
		{
			if (my.health <= 0) {break;} // the healer has to die if its health goes below zero
			if (player.health <= 0) {break;} // the healer has to die if player's health goes below zero
			if (player.health == 100) // the player isn't injured? Then don't do anything for the player!
			{
				if (my.health == 100) // the healer doesn't need to be healed? Then don't do anything for the healer!
				{
					my.skill22 += 4 * time_step; // 4 gives the "stand" animation speed
					ent_animate(my, "idle", my.skill22, ANM_CYCLE);
				}
				else // the healer was injured, so it needs to heal itself (the player is in good health ;)
				{
					healer_particles();
					my.skill22 += 4 * time_step; // 4 gives the healing animation speed
					// the "attack" animation for this model can serve as a placeholder "healing" animation			
					ent_animate(my, "attack", my.skill22, ANM_CYCLE); 
					my.health += 1 * time_step; // this is the line that takes care of the actual healing
					my.health = minv(100, my.health); // make sure that the healer's health doesn't exceed 100
				}
			}
			else // the player needs to be healed?
			{
				player_particles();
				vec_set(temp, player.x); 
				vec_sub(temp,my.x); 
				vec_to_angle(my.pan, temp); // rotate the healer towards the player

				if (player.health < 0) {break;} // don't do anything if the player is dead
				my.skill22 += 4 * time_step; // 4 gives the healing animation speed
				// the "attack" animation for this model can serve as a placeholder "healing" animation			
				ent_animate(my, "attack", my.skill22, ANM_CYCLE); 
				player.health += 1 * time_step; // this is the line that takes care of the actual healing
				player.health = minv(100, player.health); // make sure that player's health doesn't exceed 100
			}
			wait (1);
		}
		// you should use smaller vertical angles here (30 degrees or so) if your game contains buildings with several stories, etc
		c_scan(my.x, my.pan, vector(360, 50, 2000), SCAN_ENTS | SCAN_LIMIT); // scan for crumbs that are placed up to 2000 quants away
		if (you) // a crumb was detected?
		{
			target_crumb = you; // the closest crumb to the npc is set to "you" by c_scan
			// rotate the npc towards the crumb
			vec_set(temp, target_crumb.x);
			vec_sub(temp, my.x);
			vec_to_angle(my.pan, temp);
			// the npc looks at the target crumb now
			while (vec_dist (my.x, target_crumb.x) > 30) // the npc moves until it comes close to target_crumb
			{
				if (my.health <= 0) {break;} // the healer has to die if its health goes below zero
				my.skill22 += 12 * time_step; // 15 gives the "walk" animation speed
				c_move(my, vector(14 * time_step, 0, 0), nullvector, IGNORE_PASSABLE | GLIDE);
				ent_animate(my, "walk", my.skill22, ANM_CYCLE);
				wait (1);
			}
			// the npc has come close to target_crumb here
			ent_remove(target_crumb); // so remove the current target_crumb and prepare for the following crumb
		}
		wait (1);
	}
	// the healer is dead here
	my.health = 0; // needed if the player is dead (removes the green health bar from above healer's head)
	my.skill22 = 0;
	while (my.skill22 < 100)
	{
		my.skill22 += 3 * time_step; 
		ent_animate(my, "death", my.skill22, NULL); // play a one-shot "death" animation
		wait (1);
	}
	set (my, PASSABLE);
}
