////////////////////////////////////////////////////////////////////////////

SOUND* bullet_wav = "bullet.wav";

////////////////////////////////////////////////////////////////////////////

function health_indicator()
{
	set (my, PASSABLE);
	while (!player) {wait (1);}
	while (you)
	{
		vec_set (my.x, you.x);
		my.z += 60;
		my.scale_x = you.health * 0.1; // we will use skill59 aka health to store the health for each entity
		wait (1);
	}
}

function remove_pbullets() // this function runs when the bullet collides with something
{
	my.event = NULL;
	wait (1); // wait a frame to be sure (don't trigger engine warnings)
	ent_remove (my); // and then remove the bullet
}

function damage_player()
{
	if (you.skill30 != 1) {return;} // didn't collide with an enemy projectile? Then nothing should happen
	player.health -= 10;
}

function move_bullets() // moves player's bullets
{
	VECTOR bullet_speed[3]; // stores the speed of the bullet
	VECTOR temp[3];
	my.skill30 = 2; // I'm one of player's bullets
	my.emask = ENABLE_IMPACT | ENABLE_ENTITY | ENABLE_BLOCK; // the bullet is sensitive to impacts with entities and level blocks
	my.event = remove_pbullets; // when it collides with something, its event function (premove_bullets) will run
	my.pan = you.pan; // the bullet has the same pan
	my.tilt = you.tilt + 0.5 * camera.tilt; // and tilt depending on player's and camera's tilt angle
	bullet_speed.x = 100 * time_step; // adjust the speed of the bullet here; it will move in the direction given by the camera
	bullet_speed.y = 0; // the bullet doesn't move sideways
	bullet_speed.z = 0; // or up / down on the z axis
	while (my) // this loop will run for as long as the bullet exists (it isn't "NULL")
	{
		c_move (my, bullet_speed, nullvector, IGNORE_YOU); // move the bullet ignoring its creator (the player)
		wait (1);
	}
}

action players_code() // simple player and 1st person camera code
{ 
	my.health = 100;
	ent_create ("health.pcx", nullvector, health_indicator);
	VECTOR temp[3];
	player = my; // I'm the player
	my.emask = ENABLE_IMPACT | ENABLE_ENTITY;
	my.event = damage_player;
	while (my.health > 0)
	{
		vec_set(temp.x, my.x);
		temp.z -= 10000;
		my.z -= c_trace(my.x, temp.x, IGNORE_ME | USE_BOX | IGNORE_PASSABLE) - 20; // play with 40

		if (key_w + key_s) // the player is moving?
		{
			my.skill22 += 12 * time_step; // then play its "run" animation!
			ent_animate(my, "run", my.skill22, ANM_CYCLE);
		}
		else // the player is standing still?
		{
			my.skill22 += 1.5 * time_step; // then play its "stand" animation!
			ent_animate(my, "stand", my.skill22, ANM_CYCLE);
		}

		// move the player using the "W", "S", "A" and "D" keys; "10" = movement speed, "8" = rotating speed
		my.pan += 8 * ((key_a - key_d) - 0.7 * mouse_force.x) * time_step;
		c_move (my, vector(15 * (key_w - key_s) * time_step, 0, 0), nullvector, IGNORE_PASSABLE | GLIDE);
		vec_set (camera.x, vector (-400, 0, 150)); // 3rd person camera, play with these values
		vec_rotate (camera.x, player.pan);
		vec_add (camera.x, player.x);
		camera.pan = player.pan;
		camera.tilt += 3 * mouse_force.y * time_step; // on its x and y axis
		// if the player presses the left mouse button, fire about 5 bullets per second
		if ((mouse_left) && ((total_frames % 15) == 1)) 
		{
			// create the bullet at camera's position and attach it the "move_bullets" function
			ent_create ("pbullet.mdl", my.x, move_bullets); 
			snd_play(bullet_wav, 50, 0);
		}

		wait (1);
	}
	// the player is dead here
	my.skill22 = 0;
	while (my.skill22 < 100)
	{
		my.skill22 += 3 * time_step; 
		ent_animate(my, "death", my.skill22, NULL); // play a one-shot "death" animation
		wait (1);
	}
	set (my, PASSABLE);
}
